# [ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ]
#  Name:         Sitebot Hub
#  Version:      3.1                                                        
#  Last Updated: 2003-11-12                                                  
#  Author:       Original by DaRKHeaRT | Remade by F|owman
#  Contact:      F|owman on Efnet.
#  Notes:        Bad configuration might lead to errors, so be WARNED. 
#                                                                            
#   This program is free software; you can redistribute it and/or modify     
#   it under the terms of the GNU General Public License as published by     
#   the Free Software Foundation; either version 2 of the License, or        
#   (at your option) any later version.                                      
#                                                                            
#   This script is distributed in the hope that it will be useful,           
#   but WITHOUT ANY WARRANTY; without even the implied warranty of           
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            
#   GNU General Public License for more details.                                   
# [ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - ]

#-- Sitebot Main --------------------------------------------------------------------#
proc sitebot:main {} {
  uplevel #0 {
    sitebot:killoldtimers
    sitebot:init
    putlog "+--\[ SITEBOT v3.1 \]----------------------------------------------- -- --- - - -"
    sitebot:loadconf
    sitebot:loadapi
    sitebot:loadskin
    sitebot:functions
    sitebot:hub
    putlog "| $site.. BOT UP.. Fingers Crossed.. Loading Sections"
    sitebot:updater
    sitebot:addonsearch
    sitebot:checkscripts
    if {[info exists enabled(announce)]} { if $enabled(announce) { putlog "| SITEBOT: announce addon located.... starting tail" ; sitebot:announce } }
    putlog "| $site $ver"
    putlog "`------------------------------------------- -- \[ [b]Sitebot[b] \] - - "
  }
}

proc sitebot:killoldtimers {} {
  foreach this [timers] {
    if {([string compare [lindex $this 1] "leafchk"] == 0) || ([string compare [lindex $this 1] "sitebot:autochkupdate"] == 0)} {
      killtimer [lindex $this 2]
    }
  }
}

proc sitebot:init {} {
  uplevel #0 {
    if {![info exists sitebot(api)]} { set sitebot(api) sitebot-glftpd.api }
    if {![info exists sitebot(config)]} { set sitebot(config) sitebot-glftpd.cfg }
    if {![info exists sitebot(skin)]} { set sitebot(skin) sitebot-default.skin }
    set currentconfigversion 3.1
    set currentapiversion 3.1
    set build 37
    set ver "SiteBot v3.1 Glftpd Edition"
    set verbot "SiteBot v3.1 Glftpd Edition"
    package require http 2.3
    set www "http://flowman.ath.cx/sitebot/"; # dont touch this line.
    if {![info exists enabled(updater)]} { set enabled(updater) 1 }
    if {![info exists enabled(onjoin)]} { set enabled(onjoin) 0 }
    if {![info exists enabled(autochkupdater)]} { set enabled(autochkupdater) 1 }
    if {![info exists enabled(debug)]} { set enabled(debug) 0 }
    if {![info exists sitename]} { set sitename "The p0rn SiTE" }
    if {![info exists site]} { set site "xXx" }
    if {![info exists pub_prefix]} { set pub_prefix "!x" }
    if {![info exists dcc_prefix]} { set dcc_prefix "s" }
    if {![info exists timer(updater)]} { set timer(updater) "60*24*7" }
    if {![info exists timer(leafchk)]} { set timer(leafchk) "30" }
    if {![info exists proxy(enabled)]} { set proxy(enabled) 0 }
    if {![info exists proxy(host)]} { set proxy(host) "myproxy.isp.com" }
    if {![info exists proxy(port)]} { set proxy(port) "8080" }
    if {![info exists typemsg]} { set typemsg "" }
    if {![info exists standard]} { set standard "14" }
    if {![info exists highlight]} { set highlight "" }
    if {![info exists glftpddir]} { set glftpddir "/glftpd" }
    if {![info exists glbindir]} { set glbindir "/glftpd/bin" }
    if {![info exists hubid]} { set hubid [rand 999999]}
    if {![info exists msgtypes(RACE)]} { set msgtypes(RACE) "ANUKEEMPTY ANUKEINC ANUKEBAN NUKE UNNUKE PRE NEWDIR SFV UPDATE UPDATEAUDIO UPDATEZIP HALFWAY RACEHALFWAY RACE NEWLEADER COMPLETE RACECOMPLETE INFOSTATS USTATS GSTATS DELDIR VIDEO_INFO INCOMPLETE WIPE-r" }
    if {![info exists msgtypes(DEFAULT)]} { set msgtypes(DEFAULT) "INVITE LOGIN LOGOUT REQUEST REQUEST2 REQFILLED" }
    if {![info exists sections]} { set sections "Svcd xXx"}
    if {![info exists echovars(ANUKEEMPTY) ]} { set echovars(ANUKEEMPTY) "release timenow nuketime" }
    if {![info exists echovars(ANUKEINC) ]} { set echovars(ANUKEINC) "release nukewarn nuketime" }
    if {![info exists echovars(ANUKEBAN) ]} { set echovars(ANUKEBAN) "release banword nukewarn nuketime" }
    if {![info exists echovars(NUKE) ]} { set echovars(NUKE) "pf" }
    if {![info exists echovars(UNNUKE) ]} { set echovars(UNNUKE) "pf" }
    if {![info exists echovars(PRE) ]} { set echovars(PRE) "pf group user dirsize files sfvdir" }
    if {![info exists echovars(NEWDIR) ]} { set echovars(NEWDIR) "pf user group tagline" }
    if {![info exists echovars(SFV) ]} { set echovars(SFV) "pf release files" }
    if {![info exists echovars(UPDATE) ]} { set echovars(UPDATE) "pf type user group release mb" }
    if {![info exists echovars(UPDATEAUDIO) ]} { set echovars(UPDATEAUDIO) "pf type release files artist year" }
    if {![info exists echovars(UPDATEZIP) ]} { set echovars(UPDATEZIP) "pf type release mb files" }
    if {![info exists echovars(HALFWAY) ]} { set echovars(HALFWAY) "pf type release user group mb files percent speed" }
    if {![info exists echovars(RACEHALFWAY) ]} { set echovars(RACEHALFWAY) "pf type release user group mb files percent speed gtop gmb gfiles gpercent gspeed" }
    if {![info exists echovars(RACE) ]} { set echovars(RACE) "pf user group racers release speed" }
    if {![info exists echovars(NEWLEADER) ]} { set echovars(NEWLEADER) "pf user group mb files percent speed release " }
    if {![info exists echovars(COMPLETE) ]} { set echovars(COMPLETE) "pf type release mb files speed time racers groups fast_user fast_group fast_speed" }
    if {![info exists echovars(RACECOMPLETE) ]} { set echovars(RACECOMPLETE) "pf type release mb files speed time racers groups comp fast_user fast_group fast_speed slow_user slow_group slow_speed" }
    if {![info exists echovars(USTATS) ]} { set echovars(USTATS) "pf type place user group mb files percent speed" }
    if {![info exists echovars(GSTATS) ]} { set echovars(GSTATS) "pf type place group mb files percent speed" }
    if {![info exists echovars(INFOSTATS) ]} { set echovars(INFOSTATS) "pf text" }
    if {![info exists echovars(DELDIR) ]} { set echovars(DELDIR) "pf user group tagline" }
    if {![info exists echovars(VIDEO_INFO) ]} { set echovars(VIDEO_INFO) "pf program_stream_type program_avg_bit_rate video_mpeg_type video_frame_rate video_horizontal_size video_vertical_size video_aspect_ratio audio_mpeg_type audio_bitrate audio_sampling_frequency audio_mode" }
    if {![info exists echovars(INCOMPLETE) ]} { set echovars(INCOMPLETE) "pf user group release" }
    if {![info exists echovars(WIPE-r) ]} { set echovars(WIPE-r) "pf user group tagline" }
    if {![info exists echovars(INVITE) ]} { set echovars(INVITE) "nickname username group" }
    if {![info exists echovars(LOGIN) ]} { set echovars(LOGIN) "hostname ip user group tagline" }
    if {![info exists echovars(LOGOUT) ]} { set echovars(LOGOUT) "hostname ip user group tagline" }
    if {![info exists echovars(REQUEST) ]} { set echovars(REQUEST) "user request" }
    if {![info exists echovars(REQUEST2) ]} { set echovars(REQUEST2) "user request for" }
    if {![info exists echovars(REQFILLED) ]} { set echovars(REQFILLED) "user action request" }
    if {![info exists mask(ANUKEEMPTY) ]} { set mask(ANUKEEMPTY) "%sitein%c0 [b]AUTONUKER%c1:[b]%c2 [b]%release[b] %c1is empty or incomplete after%c2 [b]%timenow[b]%c1. Will be nuked when its%c2 [b]%nuketime[b]%c1 old." }
    if {![info exists mask(ANUKEINC) ]} { set mask(ANUKEINC) "%sitein%c0 [b]AUTONUKER%c1:[b]%c2 [b]%release[b] %c1has not been completed within%c2 [b]%nukewarn[b]%c1. Will be nuked when its%c2 [b]%nuketime[b]%c1 old." }
    if {![info exists mask(ANUKEBAN) ]} { set mask(ANUKEBAN) "%sitein%c0 [b]AUTONUKER%c1:[b]%c2 [b]%release[b]%c1 -%c2[b] %banword[b]%c1 is not allowed. Will be nuked once its%c2 [b]%nuketime[b]%c1 old." }
    if {![info exists mask(NUKE) ]} { set mask(NUKE) "%sitein[b] %c1-%c0%type %multx%c1-[b]%c2 [b]%dir[b]%c1 (Nuker:%c2 [b]%nuker[b]%c1 Nukee(s):%c2 [b]%nukee[b]%c1 Reason:%c2 [b]%reason[b]%c1)" }
    if {![info exists mask(UNNUKE) ]} { set mask(UNNUKE) "%sitein[b] %c1-%c0%type %multx%c1-[b]%c2 [b]%dir[b]%c1 (Nuker:%c2 [b]%nuker[b]%c1 Nukee(s):%c2 [b]%nukee[b]%c1 Reason:%c2 [b]%reason[b]%c1)" }
    if {![info exists mask(PRE) ]} { set mask(PRE) "%sitein%c0 [b]%path PRE%c1:[b]%c2 [b]%rel[b]%c1 at%c2 [b]%now[b]%c1 by%c2 [b]%user[b]%c1 /%c2 [b]%group[b]%c1 \[%c2 [b]%dirsize%c1[b]M in%c2 [b]%files%c1[b]F %c2[b]%sfvdir%c1[b]Dir(s) \]" }
    if {![info exists mask(NEWDIR) ]} { set mask(NEWDIR) "%sitein%c0 [b]NEW RELEASE%c1:[b]%c2 -%path- [b]%rel[b] %c1at%c2 [b]%now[b]%c1 by%c2 [b]%user[b]%c1 /%c2 %group%c1. \[%c2%tagline%c1\]" }
    if {![info exists mask(SFV) ]} { set mask(SFV) "%sitein%c0 [b]SFV%c1:[b] Got SFV for%c2 %release%c1. Expecting %c2[b]%files[b]%c1F." }
    if {![info exists mask(UPDATE) ]} { set mask(UPDATE) "%sitein%c0 [b]UPDATE%c1:%c2 %user[b]%c1 /%c2 %group%c1 was the first to upload file in%c2 %release%c1. Expecting %c2[b]%mb[b]%c1mB." }
    if {![info exists mask(UPDATEAUDIO) ]} { set mask(UPDATEAUDIO) "%sitein%c0 [b]UPDATE%c1:[b] Got MP3 info for%c2 %release%c1. Expecting%c2 [b]%files[b]%c1F of%c2 [b]%artist[b]%c1 from%c2 [b]%year[b]%c1." }
    if {![info exists mask(UPDATEZIP) ]} { set mask(UPDATEZIP)	"%sitein%c0 [b]UPDATE%c1:b[b] Got DiZ for%c2 [b]%release[b]%c1. Expecting%c2 [b]%mb[b]%c1mB in%c2 [b]%files[b]%c1F." }
    if {![info exists mask(HALFWAY) ]} { set mask(HALFWAY) "%sitein%c0 [b]HALFWAY%c1:[b]%c2 %release%c1 is in halfway. Leading uploader is%c2 [b]%user[b]%c1 /%c2 %group%c1 \[%c2[b]%mb[b]%c1mB %c2[b]%files[b]%c1F %c2[b]%percent[b]%c1% %c2[b]%speed[b]%c1kB/s\]." }
    if {![info exists mask(RACEHALFWAY) ]} { set mask(RACEHALFWAY) "%sitein%c0 [b]HALFWAY%c1:[b]%c2 %release%c1 is in halfway. Leading uploader is%c2 [b]%user[b]%c1 /%c2 %group%c1 \[%c2[b]%mb[b]%c1mB %c2[b]%files[b]%c1F %c2[b]%percent[b]%c1% %c2[b]%speed[b]%c1kB/s\]. Leading group is%c2 [b]%gtop[b]%c1 \[%c2[b]%gmb[b]%c1mB %c2[b]%gfiles[b]%c1F %c2[b]%gpercent[b]%c1% %c2[b]%gspeed[b]%c1kB/s\]." }
    if {![info exists mask(RACE) ]} { set mask(RACE) "%sitein%c0 [b]NEW RACER%c1:%c2 %user[b]%c1 /%c2 %group%c1 is racing \[%c2 %racers %c1\] on%c2 %release%c1 @%c2 [b]%speed[b]%c1kB/s." }
    if {![info exists mask(NEWLEADER) ]} { set mask(NEWLEADER) "%sitein%c0 [b]NEW LEADER%c1:%c2 %user[b]%c1 /%c2 %group%c1 takes the lead in%c2 %release%c1 / \[%c2[b]%mb[b]%c1mB %c2[b]%files[b]%c1F %c2[b]%percent[b]%c1% %c2[b]%speed[b]%c1kB/s\]." }
    if {![info exists mask(COMPLETE) ]} { set mask(COMPLETE) "%sitein%c0 [b]COMPLETE%c1:[b]%c2 %release%c1 \[ %c2[b]%mb[b]%c1mB %c2[b]%files[b]%c1F at%c2 [b]%speed[b]%c1kB/s -%c2 %time%c1\] was completed by%c2 [b]%racers[b]%c1 racer(s) from%c2 %groups%c1 groups(s). Fastest upload by %c2[b]%fast_user[b]%c1 /%c2 %fast_group%c1 at%c2 [b]%fast_speed[b]%c1kB/s." }
    if {![info exists mask(RACECOMPLETE) ]} { set mask(RACECOMPLETE) "[b]COMPLETE%c1:[b]%c2 %release%c1 \[ %c2[b]%mb[b]%c1mB %c2[b]%files[b]%c1F at%c2 [b]%speed[b]%c1kB/s -%c2 %time%c1\] was completed by%c2 [b]%racers[b]%c1 racer(s) from%c2 %groups%c1 groups(s). Compression method: m%c2[b]%comp[b]%c1. Fastest upload by %c2[b]%fast_user[b]%c1 /%c2 %fast_group%c1 at%c2 [b]%fast_speed[b]%c1kB/s. Slowest upload by %c2[b]%slow_user[b]%c1 /%c2 %slow_group%c1 at%c2 [b]%slow_speed[b]%c1kB/s." }
    if {![info exists mask(DELDIR) ]} { set mask(DELDIR) "%sitein%c0 [b]DELETED%c1:[b]%c2 -%path- [b]%rel[b]%c1 by%c2 [b]%user[b]%c1 /%c2 %group%c1." }
    if {![info exists mask(USTATS) ]} { set mask(USTATS) "%sitein%c2 %place%c1.%c2 [b]%user[b]%c1 /%c2 %group%c1 \[%c2[b]%mb[b]%c1mB %c2[b]%files[b]%c1F %c2[b]%percent[b]%c1% %c2[b]%speed[b]%c1kB/s\]." }
    if {![info exists mask(GSTATS) ]} { set mask(GSTATS) "%sitein%c2 %place%c1.%c2 [b]%group[b]%c1 \[%c2[b]%mb[b]%c1mB %c2[b]%files[b]%c1F %c2[b]%percent[b]%c1% %c2[b]%speed[b]%c1kB/s\]." }
    if {![info exists mask(INFOSTATS) ]} { set mask(INFOSTATS) "%sitein%c2 %text" }
    if {![info exists mask(VIDEO_INFO) ]} { set mask(VIDEO_INFO) "%sitein%c0 [b]SAMPLE%c1:[b]%c2 [b]%rel[b] %c1\[%c0[b]STREAM[b]%c1:%c2 [b]%program_stream_type[b]%c1@%c2[b]%program_avg_bit_rate[b]%c1kbps\] \[%c0[b]ViDEO[b]%c1:%c2 [b]MPEG-%video_mpeg_type %video_frame_rate[b]%c1fps%c2 [b]%video_horizontal_size[b]%c1x%c2[b]%video_vertical_size[b]%c1px%c2 [b]%video_aspect_ratio[b]%c1ar\] \[%c0[b]AUDiO[b]%c1:%c2 [b]%audio_mpeg_type[b]%c1@%c2[b]%audio_bitrate[b]%c1kbps%c2 [b]%audio_sampling_frequency[b]%c1Hz%c2 [b]%audio_mode[b]%c1\]." }
    if {![info exists mask(INCOMPLETE) ]} { set mask(INCOMPLETE) "%sitein%c0 [b]iNCOMPLETE%c1:%c2 %user[b]%c1 /%c2 %group%c1 deletede file(s) from%c2 %release%c1. Release is now%c2 [b]incomplete[b]%c1." }
    if {![info exists mask(WIPE-r) ]} { set mask(WIPE-r) "%sitein%c0 [b]WiPE%c1:%c2 %user[b]%c1 /%c2 %group%c1 just wiped%c2 [b]%rel[b]%c1." }
    if {![info exists mask(INVITE) ]} { set mask(INVITE) "%sitein%c0 [b]INViTE%c1:%c2 %sitename[b] %c1welcomes%c2 [b]%nickname[b]%c1. Invited by (%c2[b]%username[b] %c1/%c2 %group%c1)" }
    if {![info exists mask(LOGIN) ]} { set mask(LOGIN) "%sitein%c0 [b]LOGiN%c1:[b]%c2 [b]%user[b]%c1 /%c2 %group%c1 just logged in." }
    if {![info exists mask(LOGOUT) ]} { set mask(LOGOUT) "%sitein%c0 [b]LOGOUT%c1:[b]%c2 [b]%user[b]%c1 /%c2 %group%c1 just logged out." }
    if {![info exists mask(REQUEST) ]} { set mask(REQUEST) "%sitein%c0 [b]REQUEST%c1:%c2 %user[b]%c1 adds a request for%c2 [b]%request[b]%c1. Please fill ASAP." }
    if {![info exists mask(REQUEST2) ]} { set mask(REQUEST2) "%sitein%c0 [b]REQUEST%c1:%c2 %user[b]%c1 requests%c2 [b]%request[b]%c1 for%c2 [b]%for[b]%c1. Please fill ASAP." }
    if {![info exists mask(REQFILLED) ]} { set mask(REQFILLED) "%sitein%c0 [b]REQUEST%c1:%c2 %user[b]%c1 %action%c2 [b]%request[b]%c1. Good work." }
  }
}

proc sitebot:functions {} {
  uplevel #0 {
    set c0 "\003$typemsg"
    set c1 "\003$standard"
    set c2 "\003$highlight"
    set sitein  [replacevar sitein "site" "$site"]

    if $enabled(onjoin) {
      bind join - * sitebot:onjoin

      proc sitebot:onjoin { nick uhost hand chan } { global chans verbot
        if {[string match [string tolower "*$chan*"] [string tolower $chans(DEFAULT)]]} {
	    set output [replacevar welcome "ver" "{$verbot}"]
          foreach line $output { hubsend msg 5 $nick NOTICE $line }
        }
      }
    }
    bind dcc C ${dcc_prefix}saveapi sitebot:updateapi 
    bind dcc C ${dcc_prefix}savecfg sitebot:updateconf
    bind dcc C ${dcc_prefix}set sitebot:set_dcc
    bind dcc - ${dcc_prefix}msgauthor sitebot:msgauthor
    bind dcc - ${dcc_prefix}announce sitebot:announce
    bind pub - ${pub_prefix}ver sitebot:version
    bind pub - ${pub_prefix}build sitebot:build
  }
}

proc sitebot:loadskin {} { global sitebot script proxy www
  if {![file exists scripts/sitebot/$sitebot(skin)]} {
    putlog "| SITEBOT: skin file: $sitebot(skin) not in scripts dir."
    putlog "| SITEBOT: downloading $sitebot(skin)"
    if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
    set url "${www}sitebot-default.skin"
    set out [open scripts/sitebot/sitebot-default.skin w] ; set tok [http::geturl $url -channel $out] ; close $out
    set result [sitebot:checkfile scripts/sitebot/sitebot-default.skin ]
    if {$result == 0} {
      putlog "| SITEBOT: download of sitebot-default.skin unsuccessful.. file not found"
    } {
      putlog "| SITEBOT: sitebot-default.skin Successfully Downloaded"
    }
      sitebot:loadskin; return;
    } else {
      putlog "| SITEBOT: skin located.... loading"
      uplevel #0 {source scripts/sitebot/$sitebot(skin)}
    }
    putlog "`+ Searching for sitebot custom skins"
    if {[catch { set scripts [glob scripts/sitebot/sitebot-skin-*.skin] } ] != 0 } { putlog "+ No custom skin found" } {
    foreach script $scripts {
      putlog " | - Loading $script"
      uplevel #0 {source $script}
    }
    putlog "+ Finished loading skins"
  }
}

proc sitebot:loadapi {} { global sitebot apiversion currentapiversion msgtypes
  if {![file exists scripts/sitebot/$sitebot(api)]} {
    putlog "| SITEBOT: api file: $sitebot(api) not in scripts dir."
    putlog "| SITEBOT: recommended that you edit scripts/sitebot/$sitebot(api) asap..."
    set apiversion $currentapiversion
    sitebot:updateapi 0 0 0
  } else {
    putlog "| SITEBOT: api located.... loading"
    uplevel #0 {source scripts/sitebot/$sitebot(api)}
  }
  if {![info exists apiversion]} {
    putlog "| SITEBOT: cant read api version number... some idiot deleted it from the api file :)"
    unset msgtypes
    set apiversion $currentapiversion
    sitebot:updateapi 0 0 0
  }
  if {$apiversion < $currentapiversion} {
    putlog "| SITEBOT: api file is old updating... default values been used for"
    putlog "| SITEBOT: missing variables strongly recommend you edit scripts/sitebot/$sitebot(api)"
    set apiversion $currentapiversion
    unset msgtypes
    sitebot:updateapi 0 0 0
  }
  if {$apiversion == $currentapiversion} {
    putlog "| SITEBOT: api version matchs tcl version! Variables Read Succesfully!"
  }
  if {$apiversion > $currentapiversion} {
    putlog "| SITEBOT: api version is newer then tcl... no changes made"
    putlog "| SITEBOT: possibility for errors due to version mismatch"
  }
}

proc sitebot:loadconf {} { global sitebot configversion currentconfigversion
  if {![file exists scripts/sitebot/$sitebot(config)]} {
    putlog "| SITEBOT: config file: $sitebot(config) not in scripts dir."
    putlog "| SITEBOT: recommended that you edit scripts/sitebot/$sitebot(config) asap..."
    set configversion $currentconfigversion
    sitebot:updateconf 0 0 0
  } else {
    putlog "| SITEBOT: config located.... loading"
    uplevel #0 {source scripts/sitebot/$sitebot(config)}
  }
  if {![info exists configversion]} { global configversion
    putlog "| SITEBOT: cant read config version number... some idiot deleted it from the conf file :)"
    set configversion $currentconfigversion
    sitebot:updateconf 0 0 0 
  }
  if {$configversion < $currentconfigversion} {
    putlog "| SITEBOT: config file is old updating... default values been used for"
    putlog "| SITEBOT: missing variables strongly recommend you edit your conf.."
    set configversion $currentconfigversion
    sitebot:updateconf 0 0 0 
  }
  if {$configversion == $currentconfigversion} {
    putlog "| SITEBOT: config version matchs tcl version! Variables Read Succesfully!"
  }
  if {$configversion > $currentconfigversion} {
    putlog "| SITEBOT: config version is newer then tcl... no changes made"
    putlog "| SITEBOT: possibility for errors due to version mismatch"
  }
}

proc sitebot:checkscripts {} { global glbindir enabled
  putlog "| SITEBOT: checking for missing files in $glbindir dir."
  set die 0
  if {[info exists enabled(announce)]} {
    if $enabled(announce) {
      if {![file exists $glbindir/tail]} { putlog "SITEBOT: - missing \"tail\"" ; set die 1}
    }
  }
  if {$die == "1"} {
    putlog "| SITEBOT: will not load until missing files are in $glbindir"
    uplevel #0 { die }
  }
}

proc sitebot:addonsearch {} {global script addons enabled
  putlog "`+ Searching for sitebot addons"
  if {[catch { set scripts [glob scripts/sitebot/sitebot-addon-*.tcl] } ] != 0 } { putlog "- No sitebot addons found" } {
    foreach script $scripts {
      putlog " | - Loading $script"
      uplevel #0 {source $script}
    }
    putlog "+ Finished loading addons"
  }
}

proc sitebot:addversion { addonver } { global ver
   set ver "$ver +$addonver"
}

proc sitebot:version { nick uhost hand chan args } { global sitein ver c0 c1 c2 
  hubsend chan 5 $chan PRIVMSG "$sitein$c1 Is using \[$c2[b]$ver[b]$c1\]"
}

proc sitebot:build { nick uhost hand chan args } { global sitein ver c0 c1 c2 build addonbuild addon configversion
  set args [lindex $args 0];
  if { $args == ""} {
    hubsend chan 5 $chan PRIVMSG "$sitein$c1 Sitebot build \[$c2[b]sitebot-core $configversion.$build[b]$c1\]"
  } elseif { $args == "all" } {
    hubsend chan 5 $chan PRIVMSG "$sitein$c1 Sitebot build \[$c2[b]sitebot-core $configversion.$build[b]$c1\]"
    foreach type [lsort [array names addonbuild]] {
      hubsend chan 5 $chan PRIVMSG "$sitein$c1 Addon $c2[b]$type[b]$c1 build \[$c2[b]$type $addon($type).$addonbuild($type)[b]$c1\]"
    }
  } {
    foreach type $args {
      if {[info exists addonbuild($type)]} {
        hubsend chan 5 $chan PRIVMSG "$sitein$c1 Addon $c2[b]$type[b]$c1 build \[$c2[b]$type $addon($type).$addonbuild($type)[b]$c1\]"
      } {
	  hubsend chan 5 $chan PRIVMSG "$sitein$c1 No build info from addon $c2[b]$type[b]"
      }
    }
  }
}

proc sitebot:announce {hand idx arg} { global chans
  if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?  You need '.help'" ; return 0 }
  foreach chan $chans(DEFAULT) { hubsend chan 5 $chan PRIVMSG [replacevar announcement "msg" "{$arg}"] }
}

#-- WEB UPDATE ----------------------------------------------------------------------#
proc sitebot:updater {} {
  putlog "| SITEBOT: updater Loaded!"
  uplevel #0 {
   if $enabled(updater) {
    bind dcc C ${dcc_prefix}update sitebot:update
    bind dcc C ${dcc_prefix}timers debugtimers
    bind pub o ${pub_prefix}updates sitebot:updates

    proc sitebot:updates { nick uhost handle chan args } { sitebot:autochkupdate } 

    proc debugtimers {hand idx args} {
      foreach this [utimers] {putlog "$this"}
	foreach this [timers] {putlog "$this"} 
    }

    if $enabled(autochkupdater) {
	if { $timer(updater) < 60*24*2 } { set timer(updater) "60*24*2" }
      timer [expr $timer(updater)] sitebot:autochkupdate

      proc sitebot:autochkupdate { } { global build timer chans sitein sitebot addonconf enabled configversion dcc_prefix proxy www addon addonbuild c0 c1 c2
	  if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
        set url "${www}version.txt"
        set tok [http::geturl $url] ; upvar #0 $tok state
        foreach {currentversion newbuild} [split [string range [lindex $state(body) 0] 0 end] "|"] {}
        if {$configversion < $currentversion || $build < $newbuild} { 
	    hubsend pub 5 $chans(DEFAULT) PRIVMSG "$sitein$c1 New $c2[b]Sitebot[b]$c1 is out! Your Version:$c2 [b]v$configversion b$build[b]$c1  Latest Version:$c2 [b]v$currentversion b$newbuild[b]"
        }
        if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
        set url "${www}addons/version.txt"
        set tok [http::geturl $url] ; upvar #0 $tok state
        set counter "-1"
        foreach body [array names state] {
          set counter [expr $counter + 1]
          set file [lindex $state(body) $counter]
	    if {$file == ""} {continue}
          foreach {type currentversion newbuild} [split [string range $file 0 end] "|"] {}
          foreach type2 [lsort [array names addon]] {
            if {[string match $type $type2]} {
              if {$addon($type) < $currentversion || $addonbuild($type) < $newbuild} { 
	          hubsend pub 5 $chans(DEFAULT) PRIVMSG "$sitein$c1 Addon$c2 [b]$type[b]$c1 updated. Your Version:$c2 [b]v$addon($type) b$addonbuild($type)[b]$c1 Latest Version:$c2 [b]v$currentversion b$newbuild[b]"
              }
            }
          }
        }
  	  foreach this [timers] {
          if {([string compare [lindex $this 1] "sitebot:autochkupdate"] == 0)} {
            killtimer [lindex $this 2]
          }
  	  }
	  timer [expr $timer(updater)] sitebot:autochkupdate 
      }
    }

    proc sitebot:update {hand idx arg} { global sitebot addonconf enabled build configversion dcc_prefix proxy www addon addonbuild
      set cmd [lindex $arg 0]
      putlog "#$hand# ${dcc_prefix}update $arg"
      switch -exact -- $cmd {
        "tarball" {
          putdcc $idx "sitebot: connecting to webpage... attempting to download sitebot tarball"
          if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
          set url "${www}version.txt" ; set tok [http::geturl $url] ; upvar #0 $tok state ; set currentversion [lindex $state(body) 0]
          set url "${www}sitebot-glftpd-${currentversion}.tar.gz"
          set out [open scripts/sitebot/sitebot-glftpd-${currentversion}.tar.gz w] ; set tok [http::geturl $url -channel $out] ; close $out
          set result [sitebot:checkfile scripts/sitebot/sitebot-glftpd-${currentversion}.tar.gz]
          if {$result == 0} {
            putdcc $idx "Download of sitebot-glftpd-${currentversion}.tar.gz unsuccessful.. file not found"
          } {
            putdcc $idx "sitebot: sitebot-glftpd-${currentversion}.tar.gz Successfully Downloaded"
          }
        } "deladdon" {
          set file [lindex $arg 1]
          if { $file == "" } {putdcc $idx "Usage: .${dcc_prefix}update deladdon <addon_name>" ; return 0 }
          putdcc $idx "sitebot: request to remove addon: $arg"
          if {![file exists scripts/sitebot/sitebot-addon-${file}.tcl]} { putdcc $idx "scripts/sitebot/sitebot-addon-${file}.tcl not found." ; return 0 }
          set result [exec rm scripts/sitebot/sitebot-addon-${file}.tcl]
          putlog "- removing $file variables"
          foreach type [lsort [array names addonconf]] {
            foreach {type2 variable} [split $type "_"] {}
            if {[string match $type2 $file]} {
              unset addonconf($type)
	        if {[info exists $file]} { unset $file }
            }
          }
          foreach type [lsort [array names enabled]] {
            foreach {type2 setting} [split $type "_"] {}
            if {[string match $type2 $file]} {
	        unset enabled($type)
            }
          }
	    if {[info exists $addon($file)]} { unset $addon($file) }
	    if {[info exists $addonbuild($file)]} { unset $addonbuild($file) }
	    putlog "- removed $file variables"
          sitebot:addonsearch
          sitebot:updateconf 0 0 0
          putdcc $idx "sitebot: sitebot-addon-${file}.tcl removed. Please type .rehash for changes to take effect"
        } "addonlist" {
	    putdcc $idx "+--\[ Getting addons list. \]-------------------------------- -- --- - - -"
          if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
          set url "${www}addons/list.txt"
          set tok [http::geturl $url] ; upvar #0 $tok state
          set counter "-1" ; foreach body [array names state] { set counter [expr $counter + 1] ; set file [lindex $state(body) $counter] ; if {$file == ""} {continue} ;putdcc $idx "| $file" }
	    putdcc $idx "`-------------------------------------- -- \[ [b]Sitebot[b] \] - - "
        } "getaddon" {
          set file [lindex $arg 1]
          if { $file == "" } {putdcc $idx "Usage: .${dcc_prefix}update getaddon <addon_name>" ; return 0 }
          putdcc $idx "sitebot: connecting to webpage... attempting to download the addon : $file"
          set url "${www}addons/sitebot-addon-${file}.tcl"
          set out [open scripts/sitebot/sitebot-addon-${file}.tcl w] ; set tok [http::geturl $url -channel $out] ; close $out
          set result [sitebot:checkfile scripts/sitebot/sitebot-addon-${file}.tcl]
          if {$result == 0} {
            putdcc $idx "sitebot: download of $file unsuccessful.. addon doesnt exist! (.${dcc_prefix}update addonlist <-- list available addons!)"
          } {
            sitebot:addonsearch
            sitebot:updateconf 0 0 0
            putdcc $idx "sitebot: download of $file complete... go and edit ur $sitebot(config).. then type .rehash for changes to take effect"
          }
        } "addonversion" {
	    putdcc $idx "+--\[ Checking addon versions. \]---------------------------- -- --- - - -"
          if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
          set url "${www}addons/version.txt"
          set tok [http::geturl $url] ; upvar #0 $tok state
          set counter "-1"
          foreach body [array names state] {
            set counter [expr $counter + 1]
            set file [lindex $state(body) $counter]
            if {$file == ""} {continue}
            foreach {type currentversion newbuild} [split [string range $file 0 end] "|"] {}
            foreach type2 [lsort [array names addon]] {
              if {[string match $type $type2]} {
                if {$addon($type) < $currentversion || $addonbuild($type) < $newbuild} { 
                  putdcc $idx "| Your Version: $type v$addon($type) b$addonbuild($type) Latest Version: v$currentversion b$newbuild" 
	            putdcc $idx "| Seems you have an old version!"
                  putdcc $idx "| \".${dcc_prefix}update getaddon $type\" to download and install the latest version."
                  putdcc $idx "|"
                }
                if {$addon($type) == $currentversion && $addonbuild($type) == $newbuild} { putdcc $idx "| Your Version: $type v$addon($type) b$addonbuild($type) Latest Version: v$currentversion b$newbuild" ; putdcc $idx "| Versions Match! Seems your uptodate!" ; putdcc $idx "|" }
                if {$addon($type) > $currentversion || $addonbuild($type) > $newbuild} { putdcc $idx "| Your Version: $type v$addon($type) b$addonbuild($type) Latest Version: v$currentversion b$newbuild" ; putdcc $idx "| If your seeing this i mustnt be keeping my web page uptodate" ; putdcc $idx "| or someone has changed the versions or someone else is maintaining" ; putdcc $idx "| my script now! who knows?" ; putdcc $idx "|" }
              }
            }
          }
	    putdcc $idx "`-------------------------------------- -- \[ [b]Sitebot[b] \] - - "
        } "checkversion" {
	    putdcc $idx "+--\[ Checking version. \]----------------------------------- -- --- - - -"
          if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
          set url "${www}version.txt"
          set tok [http::geturl $url] ; upvar #0 $tok state
	    foreach {currentversion newbuild} [split [string range [lindex $state(body) 0] 0 end] "|"] {}
          if {$configversion < $currentversion || $build < $newbuild} { 
            putdcc $idx "| Your Version: v$configversion b$build Latest Version: v$currentversion b$newbuild" 
	      putdcc $idx "| Seems you have an old version!"
            putdcc $idx "| \".${dcc_prefix}update install\" to download and install the latest version."
            putdcc $idx "| \".${dcc_prefix}update tarball\" to just grab the latest pack."
          }
          if {$configversion == $currentversion && $build == $newbuild} { putdcc $idx "| Your Version: v$configversion b$build Latest Version: v$currentversion b$newbuild" ; putdcc $idx "| Versions Match! Seems your uptodate!" }
          if {$configversion > $currentversion || $build > $newbuild} { putdcc $idx "| Your Version: v$configversion b$build Latest Version: v$currentversion b$newbuild" ; putdcc $idx "| If your seeing this i mustnt be keeping my web page uptodate" ; putdcc $idx "| or someone has changed the versions or someone else is maintaining" ; putdcc $idx "| my script now! who knows?" }
	    putdcc $idx "`-------------------------------------- -- \[ [b]Sitebot[b] \] - - "
        } "install" {
          set choice [lindex $arg 1]
 	    if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
          set url "${www}version.txt"
          set tok [http::geturl $url] ; upvar #0 $tok state
          foreach {currentversion newbuild} [split [string range [lindex $state(body) 0] 0 end] "|"] {}

          if {$choice != "nocheck"} {
  	    putdcc $idx "sitebot: checking to makesure your running an old version."
     	    if {$build < $newbuild} { putdcc $idx " Your Version: v$configversion b$build Latest Version: v$currentversion b$newbuild" }
            if {$build == $newbuild} { putdcc $idx " Your Version: v$configversion b$build Latest Version: v$currentversion b$newbuild" ; putdcc $idx " Versions Match! Seems your already uptodate! ... Exiting Update" ; return 0 }
            if {$build > $newbuild} { putdcc $idx " Your Version: v$configversion b$build Latest Version: v$currentversion b$newbuild" ; putdcc $idx " If your seeing this i mustnt be keeping my web page uptodate" ; putdcc $idx " or someone has changed the versions or someone else is maintaining" ; putdcc $idx " my script now! who knows? ... Exiting Update" ; return 0 }
          }

          putdcc $idx "connecting to webpage... attempting to upgrade.. fingers crossed :)"
          if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
          set url "${www}list.txt"
          set tok [http::geturl $url] ; upvar #0 $tok state

          file mkdir scripts/sitebot
	      file mkdir scripts/sitebot/extras
	      file mkdir scripts/sitebot/extras/source
	      file mkdir scripts/sitebot/extras/misc
	
          set counter "-1"
	      foreach body [array names state] {
		    incr counter ; set file [lindex $state(body) $counter] 
		    if {$file == ""} {continue}
		    putdcc $idx "downloading : ${www}$file"
		    set url "${www}$file"
		    set out [open scripts/sitebot/$file w] ; set tok [http::geturl $url -channel $out] ; close $out
		    set result [sitebot:checkfile scripts/sitebot/$file]
		    if {$result == 0} {
		      putdcc $idx "missing file : ${www}$file"
		    } {
              putdcc $idx "downloaded : ${www}$file"	      
		    }
	      }

	      if $proxy(enabled) {http_config -proxyhost $proxy(host) -proxyport(port)}
          set url "${www}/updateinfo.txt"
          set tok [http::geturl $url] ; upvar #0 $tok state
	      set counter "-1" ; foreach body [array names state] { set counter [expr $counter + 1] ; set file [lindex $state(body) $counter] ; putdcc $idx "$file" }
          putdcc $idx ""
          sitebot:savecfg 0 0 0
          sitebot:saveapi 0 0 0
          putdcc $idx "Upgrade to SiteBot $currentversion Complete.. Type .restart for changes to take effect."
          putdcc $idx ""
	      putdcc $idx "Please look in sitebot-glftpd.changelog for changes (in your eggdrop scripts dir)"
        }
	  
        default {
	    putdcc $idx "+--\[ .supdate help \]----------------------------------------------------------- -- --- - - -"
          putdcc $idx "| .${dcc_prefix}update checkversion     - checks to see if you have the latest version"
          putdcc $idx "| .${dcc_prefix}update tarball          - downloads latest sitebot tar.gz to your scripts/sitebot dir"
          putdcc $idx "| .${dcc_prefix}update install          - downloads and installs latest sitebot-glftpd tcl"
 	    putdcc $idx "` .${dcc_prefix}update install nocheck  - downloads and installs latest sitebot-glftpd tcl (doesnt makesure your running an old version)"
	    putdcc $idx ""  
          putdcc $idx " .${dcc_prefix}update addonversion     - checks to see if you have the latest addon versions"
          putdcc $idx "| .${dcc_prefix}update addonlist        - lists available addons"
          putdcc $idx "| .${dcc_prefix}update getaddon <name>  - download and install an addon."
          putdcc $idx "| .${dcc_prefix}update deladdon <name>  - delete an addon from your scripts/sitebot dir."
	    putdcc $idx "`------------------------------------------------------------ -- \[ [b]Sitebot[b] \] - - "
        }
      }
    }
  }
 }
}

#-- SAVE API ------------------------------------------------------------------------#
proc sitebot:updateapi {hand idx arg} {
 uplevel #0 {
  set file [open $sitebot(api) w]
  puts $file "#-- Sitebot API v$currentapiversion ------------------------------------------------------------------#"
  puts $file "set apiversion $currentapiversion; 	# dont touch this line."
  puts $file ""
  puts $file "set msgtypes\(RACE\)    \"$msgtypes(RACE)\""
  puts $file "set msgtypes\(DEFAULT\) \"$msgtypes(DEFAULT)\""
  puts $file ""
  puts $file "set sections \"$sections\""
  puts $file ""
  puts $file "set chans(DEFAULT) \" #xXx \""
  foreach type $msgtypes(DEFAULT) {
    if {![info exists chans($type)]} {set chans($type) " #xXx " }
    puts $file "set chans($type) \"$chans($type)\""
  }
  puts $file ""
  puts $file "#-- Enable/Disable Announce ----------------------------------------------------------#"
  foreach type $msgtypes(RACE) {
    if {![info exists enabled_announce($type)]} {set enabled_announce($type) "1"}
    puts $file "set enabled_announce($type) $enabled_announce($type)"
  }
  foreach type $msgtypes(DEFAULT) {
    if {![info exists enabled_announce($type)]} {set enabled_announce($type) "0"}
    puts $file "set enabled_announce($type) $enabled_announce($type)"
  }
  puts $file ""
  puts $file "#-- Sections -------------------------------------------------------------------------#"
  foreach type $msgtypes(RACE) {
    if {![info exists chans(DEFAULT-$type)]} {set chans(DEFAULT-$type) " #xXx " }
    puts $file "set chans(DEFAULT-$type) \"$chans(DEFAULT-$type)\""
  }
  puts $file ""
  foreach section $sections {
    if {![info exists sectionpath($section-path)]} {set sectionpath($section-path) "/path/not/set"}
    puts $file "set sectionpath($section-path) \"$sectionpath($section-path)\""
    foreach type $msgtypes(RACE) {
      if {![info exists chans($section-$type)]} {set chans($section-$type) " #xXx " }
      puts $file "set chans($section-$type) \"$chans($section-$type)\""
    }
    puts $file ""
  }
  puts $file "#-- Echo Variables -------------------------------------------------------------------#"
  foreach type $msgtypes(RACE) {
    if {![info exists echovars($type)]} {set echovars($type) "" }
    puts $file "set echovars($type) \"$echovars($type)\""
  }
  foreach type $msgtypes(DEFAULT) {
    if {![info exists echovars($type)]} {set echovars($type) "" }
    puts $file "set echovars($type) \"$echovars($type)\""
  }
  puts $file ""
  puts $file "#-- Mask -----------------------------------------------------------------------------#"
  foreach type $msgtypes(RACE) {
    if {![info exists mask($type)]} {set mask($type) "" }
    puts $file "set mask($type) \"[filt $mask($type)]\""
  }
  foreach type $msgtypes(DEFAULT) {
    if {![info exists mask($type)]} {set mask($type) "" }
    puts $file "set mask($type) \"[filt $mask($type)]\""
  }
  close $file
  exec mv $sitebot(api) scripts/sitebot
  putlog "API file: $sitebot(api) updated successfully."
  unset file
 }
}

#-- SAVE CONF -----------------------------------------------------------------------#
proc sitebot:updateconf {hand idx arg} {
 uplevel #0 {
  set file [open $sitebot(config) w]
  puts $file "#-- Sitebot Conf v$currentconfigversion -----------------------------------------------------------------#"
  puts $file " set configversion $currentconfigversion; 			# dont touch this line."
  puts $file ""
  puts $file "#-- Enable & Dsiable Functions --------------------------------------------------------#"
  foreach type [lsort [array names enabled]] {
    if {![info exists enabled($type)]} {set enabled($type) "0"}
    puts $file "set enabled($type) $enabled($type);	# (0=off/1=on)"
  }
  puts $file ""
  puts $file "#-- Prefix & Sitename -----------------------------------------------------------------#"
  puts $file "set sitename \"$sitename\"; # Full Site Name"
  puts $file "set site \"$site\"; # Short Site Name"
  puts $file "set pub_prefix \"$pub_prefix\"; # prefix before public commands."
  puts $file "set dcc_prefix \"$dcc_prefix\"; # Letter before commands in dcc chat"
  puts $file ""
  puts $file "#-- Colors ----------------------------------------------------------------------------#"
  puts $file "set typemsg \"$typemsg\"; # Type"
  puts $file "set standard \"$standard\"; # Standard"
  puts $file "set highlight \"$highlight\"; # Highlight"
  puts $file ""
  puts $file "#-- Updater Proxy Setting -------------------------------------------------------------#"
  puts $file "# If you need to use a proxy to look at web pages from your shell and you"
  puts $file "# are using the update feature in the sitebot then change the following:"
  puts $file "set timer(updater) \"$timer(updater)\"; #Check for updates once everyweek."
  puts $file ""
  puts $file "set proxy(enabled) \"$proxy(enabled)\"; # 1 = yes 0 = no"
  puts $file "set proxy(host) \"$proxy(host)\"; # Proxy Host"
  puts $file "set proxy(port) \"$proxy(port)\"; # Proxy Port"
  puts $file ""
  puts $file "#-- Glftpd Location ---------- Probably dont need to change this... -------------------#"
  puts $file "set glftpddir \"$glftpddir\";"
  puts $file "set glbindir \"$glbindir\";"
  foreach type [lsort [array names addonconf]] {
    if {![info exists addonconf($type)]} {set addonconf($type) " "}
    if {[lsearch -exact [string range $addonconf($type) 0 1] "#-"]} {
      foreach {type2 variable} [split [string range $type 0 end] "_"] {}
      puts $file "set $type2\($variable\) \"[filt $addonconf($type)]\";"
    } {
      puts $file ""
      puts $file "$addonconf($type)"
    }
  }
  close $file
  exec mv $sitebot(config) scripts/sitebot
  putlog "Config file: $sitebot(config) updated succesfully."
  unset file
 }
}

#-- HUB PART ------------------------------------------------------------------------#
proc sitebot:hub {} {
  uplevel #0 {
    bind bot - leafhere leafadd
    bind bot - leafcmd leafcmd
    bind link - * leaflink
    bind disc - * leafdisc
    bind evnt - rehash hubupdateid

    utimer 5 leafchk

    bind dcc C ${dcc_prefix}leafbots botsconn

    proc botsconn {hand idx args} { global leafbots
      foreach leaf [lsort [array names leafbots]] {
	    putdcc $idx " Leaf Name: $leaf" ; putdcc $idx " Flags: [lindex $leafbots($leaf) 0]  ID: [lindex $leafbots($leaf) 1]  "
	  }
    }

    proc hubupdateid {type} { global hubid
  	  if {[info exists hubid]} { set hubid [rand 999999]}
    }

    proc leafchk {} { global botnick pub_prefix hubid timer
	  putallbots "leafchk $pub_prefix $hubid"
	  putlog "SITEBOT: Checking leafs"
      timer [expr $timer(leafchk)] leafchk
    }

    proc leaflink {botname via} { global botnick pub_prefix hubid
	  putbot $botname "leafchk $pub_prefix $hubid"
	  putlog "SITEBOT: Checking linked bot $botname. Thats connecting through $via."
    }

    proc leafdisc {botname} { global leafbots
	  if {[info exists leafbots($botname)]} { putlog "SITEBOT: Disconnected bot $botname" }
      if {[info exists leafbots($botname)]} { unset leafbots($botname)}
    }

    proc leafadd {hand idx args} { global leafbots
	  set args [lindex $args 0]
	  if {[string match *$hand* [lsort [array names leafbots]]]} {
	    if {![string match [lindex $args 1] [lindex $leafbots($hand) 1]]} {
	      set leafbots($hand) "$args"
	      putlog " Changed Leaf: $hand" ; putlog " Flags: [lindex $leafbots($hand) 0]  ID: [lindex $leafbots($hand) 1]  "
	    }
 	  } {
  	    set leafbots($hand) "$args"
	    putlog " Found Leaf: $hand" ; putlog " Flags: [lindex $leafbots($hand) 0]  ID: [lindex $leafbots($hand) 1]  "
	  }
    }

    proc leafcmd {hand idx args} {
	  eval [lindex $args 0]
    }

    proc hubsend {mtype flag dest args output {section ""}} { global leafbots
	  switch $mtype {
	    msg {
	      if {[llength $dest] > 1} {
	        foreach {leaf leafnick} $dest {}
	  	    if [regexp $flag [lindex $leafbots($leaf) 0]] {
	          set str "leafmsg" ; lappend str $args $leafnick $output 
	          putbot $leaf $str
	        }
          } {
	        puthelp "$args $dest :$output" 
          }
        }
	  pub {
	    foreach leaf [array names leafbots] {
	  	if [regexp $flag [lindex $leafbots($leaf) 0]] {
	    	  set str "leafpub" ; lappend str $output $section
	    	  putbot $leaf $str
	      }
	    }
	    foreach chan $dest { putquick "$args $chan :$output" }
 	  }
	  chan { 
	    if {[llength $dest] > 1} {
	      foreach {leaf chan} $dest {}
	  	if [regexp $flag [lindex $leafbots($leaf) 0]] {
	        set str "leafmsg" ; lappend str $args $chan $output
	        putbot $leaf $str
	      }
	    } {
	      foreach chan $dest { putquick "$args $chan :$output" }
	    }
	  }
	}
    }
  }
}

#-- SSET PART -----------------------------------------------------------------------#
proc sitebot:set_dcc { hand idx arg } { global dcc_prefix setvars
  foreach line [sitebot:set $arg] { putdcc $idx $line }
}

proc sitebot:set { args } { global addon
  global enabled sitename site pub_prefix dcc_prefix typemsg standard highlight timer proxy glftpddir glbindir sitebot
  global msgtypes sections sectionpath mask enabled_announce echovars types chans
  foreach globvar [array names addon] { global $globvar }

  set dynamics "sections msgtypes"

  set args [lindex $args 0]
  set cmd [string tolower [lindex $args 0]]
  set arg [lrange $args 1 end]
  set output ""

  if {[string match "+" [string index $cmd 0]]} {
    if {[string match "*[string range $cmd 1 end]*" $dynamics]} {
      set cmd [string map -nocase "+ {}" $cmd]
      set dynamic 1
    }
  } elseif {[string match "-" [string index $cmd 0]]} {
    if {[string match "*[string range $cmd 1 end]*" $dynamics]} {
      set cmd [string map -nocase "- {}" $cmd]
      set dynamic 0
    }
  }

  if {[info exists $cmd]} {
    if {![string match *$cmd* "mask echovars enabled chans path sectionpath enabled_announce msgtypes"] && [lsearch -exact [array names addon] $cmd] == -1} {
      lappend output "+--\[ .${dcc_prefix}set $cmd \]---------------------------- -- --- - - -"
	if {![info exists dynamic]} {
        if {$arg == ""} {
          lappend output "| $cmd is currently set to \"[set $cmd]\""
        } {
          if { $arg == "none" } { set arg "" }
          set [list $cmd] $arg
          lappend output "| $cmd set to \"[set $cmd]\""
	    sitebot:functions
        }
        lappend output "`---------------------- -- \[ [b]Sitebot[b] \] - - "
	} {
	  if {$arg == ""} {
          lappend output "| Usage: .${dcc_prefix}set <+|->$cmd <variable>"
          lappend output "| $cmd is currently set to \"[set $cmd]\""
	  } elseif {[lsearch -exact $cmd $arg] == -1 || $dynamic == 0}  {
	    if {$dynamic == "1"} {
	      lappend $cmd $arg
            lappend output "| successfully added type $arg"
	    } {
  		set a [lsearch -exact [set $cmd] $arg]
  		if { $a >= 0 } {
    		  set $cmd [lreplace [set $cmd] $a $a]
              lappend output "| successfully deleted type $arg"
  		}
	    }
          lappend output "| $cmd set to \"[set $cmd]\""
	    sitebot:updateapi 0 0 0
	  } {
          lappend output "| $arg dose allready exist!"
          lappend output "| $cmd is currently set to \"[set $cmd]\""
	  }
        lappend output "`--------------------- -- \[ [b]Sitebot[b] \] - - "
	}
    } {
      set cmdvar [lindex $arg 0]
      set arg [lrange $arg 1 end]
      lappend output "+--\[ .${dcc_prefix}set $cmd \]--------------------------------------- -- --- - - -"
	if {![info exists dynamic]} {
        if {[lsearch -exact [array names $cmd] $cmdvar] == -1} {
          lappend output "|  valid variables are: "
          foreach line [splitlines [lsort [array names $cmd]] 6] { lappend output "|   $line " }
        } elseif {$arg == ""} {
          lappend output "| $cmd\($cmdvar\) is currently set to \"[set $cmd\($cmdvar\)]\""
        } {
          if { $arg == "none" } { set arg "" }
          set $cmd\($cmdvar\) $arg
          lappend output "| $cmd\($cmdvar\) set to \"[set $cmd\($cmdvar\)]\""
        }
        lappend output "`----------------------------- -- \[ [b]Sitebot[b] \] - - "
	} {
	  if {[lsearch -exact [array names $cmd] $cmdvar] == -1} {
          lappend output "|  valid variables are: "
          foreach line [splitlines [lsort [array names $cmd]] 6] { lappend output "|   $line " }
	  } elseif {$arg == ""} {
          lappend output "| Usage: .${dcc_prefix}set <+|->$cmd <type> <variable>"
          lappend output "| $cmd\($cmdvar\) is currently set to \"[set $cmd\($cmdvar\)]\""
	  } elseif {[lsearch -exact [set $cmd\($cmdvar\)] $arg] == -1 || $dynamic == "0"} {
	    if {$dynamic == "1"} {
	      lappend $cmd\($cmdvar\) $arg
          lappend output "| successfully added type $arg"
	    } {
  		set a [lsearch -exact [set $cmd\($cmdvar\)] $arg]
  		if { $a >= 0 } {
    		  set $cmd\($cmdvar\) [lreplace [set $cmd\($cmdvar\)] $a $a]
		  unset echovars($arg) ; unset mask($arg) ; unset enabled_announce($arg)
              lappend output "| successfully deleted type $arg"
 		}
	    }
          lappend output "| $cmd\($cmdvar\) set to \"[set $cmd\($cmdvar\)]\""
	    sitebot:updateapi 0 0 0
	  } {
          lappend output "| type $arg dose allready exist!"
          lappend output "| $cmd\($cmdvar\) is currently set to \"[set $cmd\($cmdvar\)]\""
	  }
        lappend output "`----------------------------- -- \[ [b]Sitebot[b] \] - - "
	}
    }
  } {
    lappend output "+--\[ .${dcc_prefix}set help \]------------------------------------------ -- --- - - -"
    lappend output "| valid variables in \($sitebot(config)\): "
    lappend output "|   sitename site pub_prefix dcc_prefix glftpddir glbindir"
    lappend output "|  colors: "
    lappend output "|   typemsg standard highlight "
    lappend output "| bit more complex variables: "
    lappend output "|   enabled <field> <0|1> "
    lappend output "|   timer <updater|leafchk> <value> "
    lappend output "|   proxy <enabled|host|port> <value> "
    lappend output "|"
    lappend output "| valid addon variables \($sitebot(config)\): "
    foreach type [array names addon] { foreach line [splitlines [lsort [array names $type]] 5] { lappend output "|   $type: $line" } }
    lappend output "|-------------------------------------------------------- - - -"
    lappend output "| valid variables in \($sitebot(api)\):"
    lappend output "|   <+|->msgtypes <RACE|DEFAULT> <type>"
    lappend output "|   <+|->section <sectionname>"
    lappend output "|   enabled_announce <type> <0|1>"
    lappend output "|   sectionpath <sectionname> <where to>"
    lappend output "|   chans <sectionname> <type> <channels>"
    lappend output "|   echovars <type> <info>"
    lappend output "|   mask <type> <mask>"
    lappend output "|------------------------------------------------ - -  -"
    lappend output "| valid types are: "
    foreach type [array names msgtypes] { foreach line [splitlines [lsort $msgtypes($type)] 6] { lappend output "|   $type: $line" } }
    lappend output "|"
    lappend output "| valid fields for enabled are:"
    foreach line [splitlines [lsort [array names enabled]] 6] { lappend output "|   $line" }
    lappend output "`---------------------------------------------- -- \[ [b]Sitebot[b] \] - - "
  }
  return $output
}

proc sitebot:msgauthor {hand idx arg} { global sitename sitein logfile botnick from email
  if { ![matchattr $hand C] && ![matchattr $hand S] } { putdcc $idx "What?  You need '.help'" ; return 0 }

  set from $hand
  set email [lindex $arg 0]
  set head "$sitename - $sitein" ; regsub -all " " $head + hed
  set msg [lrange $arg 1 end] ; regsub -all " " $msg + mssg

  if { $email == "" } {putdcc $idx "Usage: .msgauthor <youremail> <message>" ; return 0 }
  if { $msg == "" } {putdcc $idx "Usage: .msgauthor <youremail> <message>" ; return 0 }

  putdcc $idx "SITEBOT: Sending Message \"$msg\" "

  set body $hed; append body $mssg
  set var $body; append var $hand
  append var $botnick; set l [string length $var]
  set ln [expr $l + 41]

  go_connect $idx $body $ln $mssg $hed

  putdcc $idx "SITEBOT: Message successfully sent to F|owman"
}
    
proc go_connect {idx body ln mssg hed} { global from email botnick 
  if [catch {socket "wwp.icq.com" 80} sockresult] { putlog "Could not connect:  $sockresult" ; return 0 }
  putdcc $idx "SITEBOT: Socket $sockresult was opened"

  fconfigure $sockresult -translation auto -buffering line -blocking 0
  puts $sockresult "POST /scripts/WWPMsg.dll HTTP/1.1"
  puts $sockresult "Accept: application/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*"
  puts $sockresult "Referer: http://nothing.com"
  puts $sockresult "Accept-Language: en-u"
  puts $sockresult "s"
  puts $sockresult "Content-Type: application/x-www-form-urlencoded"
  puts $sockresult "Accept-Encoding: gzip, deflate"
  puts $sockresult "User-Agent: Mozilla/4.0 (compatible; MSIE 4.01; Windows 95)"
  puts $sockresult "Host: x"
  puts $sockresult "Content-Length: $ln"
  puts $sockresult "Connection: Keep-Alive"
  puts $sockresult ""
  puts $sockresult "subject=$hed&to=4331581&from=$from&fromemail=$email&body=$mssg&x=90&y=50"
  close $sockresult
  return 1
}

#-- FUNCTIONS  ----------------------------------------------------------------------#
proc n {} {return "\n"}; proc u {} {return "\037"}; proc r {} {return "\026"};
proc b {} {return "\002"}; proc c {} {return "\003"}; proc a {} {return "\001"};
proc putchanreq { chan msg } { global showrequest ; if {$showrequest == "1"} { putserv "PRIVMSG $chan : $msg" } { return 0 }; };
proc putchan { chan msg } { putserv "PRIVMSG $chan : $msg" };
proc putnot { nick msg } { putserv "NOTICE $nick : $msg" };
proc putmsg { nick msg } { putserv "PRIVMSG $nick : $msg" };
proc putnm { nick not } { global outputt ; if {$outputt == "1"} { putmsg $nick $not ; return 0 } ; putnot $nick $not ; return 0 };

proc filt {data} {
  regsub -all -- \\\\ $data \\\\\\\\ data; regsub -all -- \\\[ $data \\\\\[ data; regsub -all -- \\\] $data \\\\\] data
  regsub -all -- \\\} $data \\\\\} data; regsub -all -- \\\{ $data \\\\\{ data; regsub -all -- \\\" $data \\\\\" data; return $data
}

proc str { string key with } {
  regsub -all -nocase "$key" $string "$with" string;return $string
}

proc find { list value } {
  set a [lsearch -exact $list $value]
  if { $a >= 0 } { return 1 } { return 0 }
}

proc ldelete { list value } {
  set a [lsearch -exact $list $value]
  if { $a >= 0 } {
    return [lreplace $list $a $a]
  } else {
    return $list 
  }
}

proc strreplace { string key with } {
  if ![string match "*$key*" $string] { return $string }
  set t1 [string range $string 0 [expr [string first $key $string] -1]]
  set t2 [string range $string [expr [string first $key $string] + [string length $key]] end]
  return "${t1}${with}${t2}"
}

proc replacevar { type key with } { global c0 c1 c2 sitein sitename skin pub_prefix
  set count -1
  foreach value $key {
    set count [expr $count + 1]
    set procinput($value) [lindex $with $count]
  }
  set output "$skin($type)"
  foreach value $key {
    set myoutput $procinput($value)
    if {[string match "*%$value*" $output ]} {set output [str $output %$value $myoutput]}
  } 
  if {[string match "*%sitein*" $output ]} {set output [str $output %sitein $sitein]}
  if {[string match "*%sitename*" $output ]} {set output [str $output %sitename $sitename]}
  if {[string match "*%c0*" $output ]} {set output [str $output %c0 $c0]}
  if {[string match "*%c1*" $output ]} {set output [str $output %c1 $c1]}
  if {[string match "*%c2*" $output ]} {set output [str $output %c2 $c2]}
  if {[string match "*%prefix*" $output ]} {set output [str $output %prefix $pub_prefix]}
  return $output 
}

proc replacedef { output } { global c0 c1 c2 sitein sitename skin
  if {[string match "*%sitein*" $output ]} {set output [str $output %sitein $sitein]}
  if {[string match "*%sitename*" $output ]} {set output [str $output %sitename $sitename]}
  if {[string match "*%c0*" $output ]} {set output [str $output %c0 $c0]}
  if {[string match "*%c1*" $output ]} {set output [str $output %c1 $c1]}
  if {[string match "*%c2*" $output ]} {set output [str $output %c2 $c2]}
  return $output 
}

proc sitebot:checkfile {fn} {
  set check [open $fn r]
  gets $check line
    if {[string index $line 0] == "<"} {
      close $check
      file delete $fn
      return 0
    }
  close $check ; return 1
}
    
proc splitlines { info length } {
        set times [expr [llength $info] / $length ]
        set extra [lrange $info [expr [llength $info] - [expr [llength $info] - [expr $times * $length ]]] end]
        set output ""; set l 0
        for {set i 0} {$i<$times} {incr i} {
                set output1 ""
                set limit [expr $length + $l ]
                for {} {$l<$limit} {incr l} { append output1 "[lindex $info $l] " }
                lappend output [string trimright $output1 " "]
        }
        if { $extra != "" } { lappend output $extra }
        return $output
}

sitebot:main
